<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" width="450">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="120px"
    >
      <el-form-item label="所属硬件" prop="hardwareId">
        <el-select
          v-model="formData.hardwareId"
          placeholder="请选择所属硬件"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in hardwareOptions"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="挂锁类型" prop="lockTypeId">
        <el-tree-select
          v-model="formData.lockTypeId"
          :data="lockTypeOptions"
          :props="{ label: 'lockTypeName', value: 'id', children: 'children' }"
          placeholder="请选择挂锁类型"
          class="!w-240px"
        />
      </el-form-item>
<!--      <el-row>-->
<!--        <el-col :span="15">-->
<!--          <el-form-item label="挂锁编码" prop="lockCode">-->
<!--            <el-input-->
<!--              v-model="formData.lockCode"-->
<!--              placeholder="请输入挂锁编码"-->
<!--              class="!w-240px"-->
<!--            />-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--        <el-col :span="8">-->
<!--          <el-form-item label-width="80">-->
<!--            <el-switch-->
<!--              v-model="autoGenFlag"-->
<!--              active-color="#13ce66"-->
<!--              active-text="自动生成"-->
<!--              @change="handleAutoGenChange"-->
<!--              v-if="formType !== 'view'"-->
<!--            />-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--      </el-row>-->
      <el-form-item label="挂锁名称" prop="lockName">
        <el-input
          v-model="formData.lockName"
          placeholder="请输入挂锁名称"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="挂锁NFC" prop="lockNfc">
        <el-input
          v-model="formData.lockNfc"
          placeholder="请输入挂锁Nfc"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="挂锁型号" prop="lockSpec">
        <el-input
          v-model="formData.lockSpec"
          placeholder="请输入挂锁型号"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="状态" prop="exStatus">
        <el-radio-group v-model="formData.exStatus">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.PADLOCK_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="备注" prop="exRemark">
        <el-input
          v-model="formData.exRemark"
          placeholder="请输入备注"
          class="!w-240px"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script lang="ts" setup>
import { ref, reactive } from 'vue'
import {DICT_TYPE, getIntDictOptions, getStrDictOptions} from '@/utils/dict'
import { handleTree } from '@/utils/tree'
import * as PadLockApi from '@/api/hw/hardware/padLock/index'
import * as HardwareApi from '@/api/hw/hardware/information/index'
import * as PadLockTypeApi from '@/api/hw/type/padLockType/index'
// import * as AutocodeApi from '@/api/system/autocode/rule'

defineOptions({ name: 'PadLockForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const autoGenFlag = ref(false) // 是否自动生成编码

const formData = ref({
  lockId: undefined,
  hardwareId: undefined,
  lockTypeId: undefined,
  lockCode: '',
  lockName: '',
  lockNfc: '',
  lockSpec: '',
  exStatus: '1',
  exRemark: ''
})

const formRules = reactive({
  // lockCode: [{ required: true, message: '挂锁编码不能为空', trigger: 'blur' }],
  lockName: [{ required: true, message: '挂锁名称不能为空', trigger: 'blur' }],
  lockNfc: [{ required: true, message: '挂锁NFC不能为空', trigger: 'blur' }]
})

const formRef = ref() // 表单 Ref
const hardwareOptions = ref([]) // 硬件选项
const lockTypeOptions = ref([]) // 挂锁类型选项

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await PadLockApi.getPadLockInfoAPI(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await PadLockApi.addPadLockAPI(data)
      message.success(t('common.createSuccess'))
    } else {
      await PadLockApi.updatePadLockAPI(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formRef.value?.resetFields()

  autoGenFlag.value = false
}

// const resetForm = () => {
//   formData.value = {
//     lockId: undefined,
//     hardwareId: undefined,
//     lockTypeId: undefined,
//     lockCode: '',
//     lockName: '',
//     lockNfc: '',
//     lockSpec: '',
//     exStatus: '1',
//     exRemark: ''
//   }
//   autoGenFlag.value = false
//   formRef.value?.resetFields()
// }

/** 自动生成编码 */
// const handleAutoGenChange = async (value: boolean) => {
//   if (value) {
//     formData.value.lockCode = await AutocodeApi.genCode('LOCK_CODE')
//   } else {
//     formData.value.lockCode = ''
//   }
// }

/** 获取硬件列表 */
const getHardwareList = async () => {
  const data = { pageNo: 1, pageSize: -1 }
  const response = await HardwareApi.listHardware(data)
  console.log(response,'yinglia')
  hardwareOptions.value = response.list.map(item => ({
    value: item.id,
    label: item.hardwareName
  }))
}

/** 获取挂锁类型列表 */
const getLockTypeList = async () => {
  const data = { pageNo: 1, pageSize: -1 }
  const response = await PadLockTypeApi.listpadLockTypeApi(data)
  lockTypeOptions.value = handleTree(response.list, 'id', 'parentTypeId', )
}

/** 初始化 **/
onMounted(async () => {
  await getHardwareList()
  await getLockTypeList()
})
</script>
